%==========================================================
% (c) 2007+ Robert Grepl, FME Brno University of Technology
%  grepl@fme.vutbr.cz, http://www.umt.fme.vutbr.cz/~rgrepl/
%==========================================================
% INVERTED PENDULUM TORQUE DRIVEN
% Ukazka navrhu rizeni pro linearizovany model

% Vytvoreno: 2007
% Updates: 
%==========================================================

clc
clear

m = 0.2;
g = 9.81;
b = 0.1;
L = 0.3;
I = m*L^2;

A = [0 , 1; m*g*L/I , -b/I];
B = [0 ; 1/I];
C = [1 , 0];
D = [0];

G = ss(A,B,C,D) % plant - State Space model

% Controller PID 
% Kp = 10
% Ti = .5
% Td = 0.1

Kp = 10
Ti = 0.5
Td = 0.1


s = tf('s');
H = Kp;
%  H = Kp * (1 + 1/(s*Ti)  )
% H = Kp * (1 + 1/(s*Ti) + s*Td  )
H = Kp * (1 + s*Td  )
%----------
% Uzavreme zapornou zpetnou vazbu
HG = H * tf(G);
Fw = HG / (1 + HG)
ssFw = ss(Fw)

% Plot
figure(1)
subplot(2,1,1)
impulse(Fw)
subplot(2,1,2)
step(Fw)
grid on

% PRO VICE POKUSU OTEVRI SIMULINKOVY MODEL
% 203/V  /  model_1dof_pendulum_casestudy.mdl

M1_limit = 10;